/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

#include <jni.h>
#include <yepCore.h>
#include <yepJavaPrivate.h>


JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V8uV8u_1V8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jbyteArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;
	Yep8u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V8uV8u_V8u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V8uV8u_1V16u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jshortArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;
	Yep16u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V8uV8u_V16u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V8sV8s_1V16s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jshortArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;
	Yep16s* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V8sV8s_V16s(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V16uV16u_1V16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jshortArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;
	Yep16u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V16uV16u_V16u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V16uV16u_1V32u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jintArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;
	Yep32u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V16uV16u_V32u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V16sV16s_1V32s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jintArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;
	Yep32s* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V16sV16s_V32s(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32uV32u_1V32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jintArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep32u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32uV32u_V32u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32uV32u_1V64u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep64u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32uV32u_V64u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32sV32s_1V64s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;
	Yep64s* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32sV32s_V64s(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V64uV64u_1V64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlongArray yArray, jint yOffset, jlongArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep64u* yPointer = NULL;
	Yep64u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V64uV64u_V64u(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32fV32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jfloatArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;
	Yep32f* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32fV32f_V32f(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V64fV64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jdoubleArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;
	Yep64f* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V64fV64f_V64f(&xPointer[xOffset], &yPointer[yOffset], &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V8uS8u_1V8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jbyteArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V8uS8u_V8u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V8uS8u_1V16u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jshortArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep16u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V8uS8u_V16u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V8sS8s_1V16s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jshortArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep16s* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V8sS8s_V16s(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V16uS16u_1V16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jshortArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V16uS16u_V16u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V16uS16u_1V32u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jintArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep32u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V16uS16u_V32u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V16sS16s_1V32s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jintArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep32s* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V16sS16s_V32s(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32uS32u_1V32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jintArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32uS32u_V32u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32uS32u_1V64u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jlongArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep64u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32uS32u_V64u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32sS32s_1V64s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jlongArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep64s* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32sS32s_V64s(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V64uS64u_1V64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlong y, jlongArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep64u* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V64uS64u_V64u(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V32fS32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jfloatArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V32fS32f_V32f(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1V64fS64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jdoubleArray productArray, jint productOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* productPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(productArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument productArray is null");
		return;
	}
	if YEP_UNLIKELY(productOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument productOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)productOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, productArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "productOffset + length exceed the length of productArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	productPointer = (*env)->GetPrimitiveArrayCritical(env, productArray, NULL);

	status = yepCore_Multiply_V64fS64f_V64f(&xPointer[xOffset], y, &productPointer[productOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, productArray, productPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV8uV8u_1IV8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Multiply_IV8uV8u_IV8u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV16uV16u_1IV16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Multiply_IV16uV16u_IV16u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV32uV32u_1IV32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Multiply_IV32uV32u_IV32u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV64uV64u_1IV64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlongArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep64u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Multiply_IV64uV64u_IV64u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV32fV32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Multiply_IV32fV32f_IV32f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV64fV64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Multiply_IV64fV64f_IV64f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV8uS8u_1IV8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Multiply_IV8uS8u_IV8u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV16uS16u_1IV16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Multiply_IV16uS16u_IV16u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV32uS32u_1IV32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Multiply_IV32uS32u_IV32u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV64uS64u_1IV64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jlong y, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Multiply_IV64uS64u_IV64u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV32fS32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Multiply_IV32fS32f_IV32f(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Multiply_1IV64fS64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Multiply_IV64fS64f_IV64f(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}
